'' SPYDRIVER .06
'' By Jeff Ledger / Aka Oldbitcollector
''
'' ##### ##### #   # ####  ####  ##### #   # ##### ####
'' #     #   #  # #  #   # #   #   #    # #  #     #   #  with apologies
'' ##### #####   #   #   # ####    #    # #  ###   ####   to SPYHUNTER
''     # #       #   #   # # #     #    # #  #     # #
'' ##### #       #   ####  #  #  #####   #   ##### #  #
''
'' Pushing the AiGeneric driver further than it was intended.
'' Can a driving game be created with a text driver? not sure.. :)
''
'' Requires a NES controller (settings below)
''
'' Current features: Fire works (A)
'' Crash into sides kills a player
'' Seasons change (winter has lost of good control)
'' Accleration/Deacceleration works (somewhat)
'' Baddie now appears and can be shot (bugs here)
'' Trees appear
'' Multiple speeds
'' Traffic appears
'' Minor sounds

'' Weird color bug now appearing, some display glitches.
'' Could I have reach the limit of what can be done with a text driver?
'' :)


CON
  '' Uncomment section for your configuration type:

'' Demoboard/Protoboard/SpinStudio Boards
   _clkmode  = xtal1 + pll16x
   _xinfreq  = 6_000_000
   video     = 12 '' I/O for composite video connection
   sound     = 10

{
'' Hydra Boards
   _clkmode  = xtal1 + pll8x
   _xinfreq  = 10_000_000
    video     = 24 '' I/O for composite video connection
    sound     = 7
}

{
'' Hybrid Boards
   _clkmode  = xtal1 + pll16x
   _xinfreq  = 6_000_000
    video     = 24 '' I/O for composite video connection
    sound     = 7
}
  ' NES bit encodings for NES gamepad 0
  NES0_RIGHT    = %00000000_00000001
  NES0_LEFT     = %00000000_00000010
  NES0_DOWN     = %00000000_00000100
  NES0_UP       = %00000000_00001000
  NES0_START    = %00000000_00010000
  NES0_SELECT   = %00000000_00100000
  NES0_B        = %00000000_01000000
  NES0_A        = %00000000_10000000

  '' joypad serial shifter settings
  JOY_CLK = 3
  JOY_LCH = 4
  JOY_DATAOUT0 = 5
  JOY_DATAOUT1 = 6

  BLACK             = $02
  GREY              = $03
  LWHITE            = $06
  BWHITE            = $07
  LMAGENTA          = $A3
  WHITE             = $AF
  RED               = $A2
  LRED              = $1A
  LPURPLE           = $1B
  PURPLE            = $03
  LGREEN            = $1C
  SKYBLUE           = $1D
  YELLOW            = $1E
  BYELLOW           = $A6
  LGREY             = $1F
  DGREY             = $08
  GREEN             = $A4
  ORANGE            = $06
  BLUE              = $A1
  CYAN              = $1C
  MAGENTA           = $FC
  LYELLOW           = $1E

  CR                = $0D
  LF                = $0A
  TAB               = $09
  BKS               = $08

  SUMMER = $A4
  WINTER = $AF
  FALL   = $1E

OBJ
     text  : "Spydriver_ai_driver"
     rr    : "RealRandom"
     snd   : "NS_sound_drv_030"

VAR
     word  Nes_Pad

PUB mainProgram   |  character_y, character_x, character_step,color, {
} board_position, { used for creating movement
} season,         { set season color for board sides
} score,          { scoreboard
} no_players,     { number of men
} acceleration,   { acceleration setting
} accel_delay,    { acceleration delay counter
} bullet_step,    { bullets shoot away from hero
} miles,          { miles counter between seasons
} move_x,         { movement_variable
} move_y,         { movement_variable
} dropoff,        { do we need to unload a car?
} b1_pos_y,       { baddie vehicle 1 position x
} b1_pos_x,       { baddie vehicle 1 position y
} b1_drive,       { baddie vehicle 1 driving? 0=no/1 & 2=yes
} b1_weapon,      { baddie vehicle 1 weapon active
} b1_accel,       { baddie vehicle 1 speed
} b1_rnd,         { randomization for baddie vehicle 1
} speed,          { used for calculating thing moving downscreen
} tree_pos_r,     { locate tree on right
} tree_pos_l,     { locate tree on left
} t1_pos_y,       { traffic vehicle 1 position x
} t1_pos_x,       { traffic vehicle 1 position y
} t1_drive,       { traffic vehicle 1 driving 0=no/1 & 2=yes
} t1_accel,       { traffic vehicle 1 speed
} t1_rnd,         { randomization for traffic vehicle 1
} t2_pos_y,       { traffic vehicle 2 position x
} t2_pos_x,       { traffic vehicle 2 position y
} t2_drive,       { traffic vehicle 2 driving 0=no/1 & 2=yes
} t2_accel,       { traffic vehicle 2 speed
} t2_rnd,         { randomization for traffic vehicle 2
} t3_pos_y,       { traffic vehicle 3 position x
} t3_pos_x,       { traffic vehicle 3 position y
} t3_drive,       { traffic vehicle 3 driving 0=no/1 & 2=yes
} t3_accel,       { traffic vehicle 3 speed
} t3_rnd          { randomization for traffic vehicle 3
}
  rr.start
  text.start(video)
  snd.start(sound)
  character_y := 20
  character_x := 19
  board_position := 1
  season:=summer
  score:=0
  acceleration:=0
  no_players:=3
  bullet_step:=0
  miles:=0
  dropoff:=1
  tree_pos_r:=2
  tree_pos_l:=4

  DrawBackground(board_position,season,score,no_players)
  text.UpdateScreen


  '' Stage positions everyone.

  repeat
    text.cls
    DrawBackground(board_position,season,score,no_players)

      'draw hero
    DrawCharacter (character_y, character_x, white, $21)
    DrawCharacter (character_y, character_x+1, white, $22)
    DrawCharacter (character_y+1,character_x,white,$41)
    DrawCharacter (character_y+1,character_x+1,white,$42)

    '' Draw trees
    drawtree(tree_pos_r,0,season+4)
    drawtree(tree_pos_l,22,season+4)

    '' Draw Baddie 1
    if b1_drive== 2
      DrawCharacter (b1_pos_y, b1_pos_x, purple, $23)
      DrawCharacter (b1_pos_y, b1_pos_x+1, purple, $24)
      DrawCharacter (b1_pos_y+1,b1_pos_x,purple,$43)
      DrawCharacter (b1_pos_y+1,b1_pos_x+1,purple,$44)
      b1_weapon++

    '' Draw Traffic 1 bug
    if t1_drive==2
      DrawCharacter (t1_pos_y, t1_pos_x, lred, $25)
      DrawCharacter (t1_pos_y, t1_pos_x+1, lred, $26)
      DrawCharacter (t1_pos_y+1,t1_pos_x,lred,$45)
      DrawCharacter (t1_pos_y+1,t1_pos_x+1,lred,$46)
    '' Draw Traffic 2 motorcycle
    if t2_drive==2
      DrawCharacter (t2_pos_y, t2_pos_x, cyan, $07)
      DrawCharacter (t2_pos_y, t2_pos_x+1, cyan, $08)
      DrawCharacter (t2_pos_y+1,t2_pos_x,cyan,$09)
      DrawCharacter (t2_pos_y+1,t2_pos_x+1,cyan,$0A)
    '' Draw Traffic 3 truck
    if t3_drive==2
      DrawCharacter (t3_pos_y, t3_pos_x, lred, $25)
      DrawCharacter (t3_pos_y, t3_pos_x+1, lred, $26)
      DrawCharacter (t3_pos_y+1,t3_pos_x,lred,$45)
      DrawCharacter (t3_pos_y+1,t3_pos_x+1,lred,$46)

    '' Check with the player to see if the hero should move or shoot.

    Nes_Pad := NES_Read_Gamepad

    if(Nes_Pad & NES0_RIGHT)
        character_x++
        if season == winter ''poor control during winter
          character_x++

    if(Nes_Pad & NES0_LEFT)
        character_x--
        if season == winter ''poor control during winter
          character_x--

    if(Nes_Pad & NES0_DOWN)
        character_y++
        acceleration--

    if character_y > 20 ''prevent hero from leaving
       character_y:=20  '' bottom of the screen.

    if acceleration < 0 '' can't drive slower than dead stop
       acceleration:=0

    if(Nes_Pad & NES0_UP)
        character_y--
        acceleration++
        dropoff:=0

    if(Nes_Pad & NES0_B) '' FIRE BULLETS
       snd.playsound(1,snd#SHAPE_NOISE,500,300)
       'color:=yellow
       if bullet_step==1
          DrawCharacter (character_y-1, character_x, yellow, $51)
          DrawCharacter (character_y-1, character_x+1, yellow, $52)
       if bullet_step==2
          DrawCharacter (character_y-3, character_x, yellow, $51)
          DrawCharacter (character_y-3, character_x+1, yellow, $52)
       if bullet_step==3
          DrawCharacter (character_y-5, character_x, yellow, $51)
          DrawCharacter (character_y-5, character_x+1, yellow, $52)
       '' Did we hit something
       if character_x-5 == b1_pos_x or character_x-3 == b1_pos_x or character_x-1 == b1_pos_x
          b1_drive:=0
          b1_pos_x:=19
          b1_pos_y:=0
          score++
          score++
          score++
          score++
          score++  '' I'm sure there is a better way to add 10 points
          score++  '' Find this later.
          score++
          score++
          score++
          score++
          snd.playsound(1,snd#SHAPE_NOISE,2000,2000)

    '' Define player boundaries forward and backward.
    if character_y == 0
       character_y := 1

    if character_y < 10
       character_y := 10

    '' Check to see if hero crashed into either side of the board

    if character_x < 3    '' Did we crash into the left side?
       acceleration := 0
       no_players--
       character_y := 20
       character_x := 19
       dropoff:=1

    if character_x > 20   '' Did we crash into the right side?
       acceleration := 0
       no_players--
       character_y := 20
       character_x := 19
       dropoff:=1

    '' Check to see if we have run out of players
    if no_players == 0
         acceleration:=0


    ''' ACCELERATION SECTION

    if acceleration == 0
       board_position:=0 '' If we are not moving, make the board still

    if acceleration > 0       ''actually moving
      if board_position > 2
          board_position:=0
      miles++
      score++
      speed++
      tree_pos_r++
      tree_pos_l++

      b1_pos_y-- ''locate baddie1

      if b1_pos_y < 2     '' Keep baddie 1 from crashing the grid
         b1_pos_y := 2

      if b1_pos_x < character_x-1 and b1_weapon == 2  '' Baddie 1 tries spikes
        b1_pos_x++
        b1_weapon:=0

      if b1_pos_x > character_x+1 and b1_weapon == 2  '' Baddie 1 tried spikes
        b1_pos_x--
        b1_weapon:=0

      t1_pos_y++ ''locate traffic1
      t2_pos_y++ ''locate traffic2
      t3_pos_y++ ''locate traffic3


    if acceleration > 5      ''moving faster
      b1_pos_y++
      b1_pos_y++
      tree_pos_r++
      tree_pos_l++
      score++
      miles++

    if acceleration > 10      ''moving faster still
      b1_pos_y++
      b1_pos_y++
      tree_pos_r++
      tree_pos_l++
      score++
      miles++

    if acceleration > 11
       acceleration :=11


    '' Reset tree if gone
    if tree_pos_r > 20
       tree_pos_r:=2

    if tree_pos_l > 20
       tree_pos_l:=4

    '' Reset bullet position to display new bullet
    if bullet_step > 3
       bullet_step := 0

    '' Determine tilt of the earth and change seasons
    if miles > 0
       season:=summer
    if miles > 400
       season:=fall
    if miles > 800
       season:=winter
    if miles > 1200
       miles:=0

    bullet_step++    '' position of bullet
    board_position++ '' change board


    ''** VAN DROPS CAR ** '' INTRO MOVIE
    if dropoff==1
       dropoff:=2
       move_x:=0
       repeat until move_x==16
         text.cls
         DrawBackground(board_position,season,score,no_players)
         drawtruck(move_x,19)
         text.Updatescreen
         waitcnt(1500_000 + cnt)
         move_x++
       text.cls
       DrawBackground(board_position,season,score,no_players)
       drawtruck(move_x,19)
       drawladder(16,19)
       text.Updatescreen
       waitcnt(10000_000 + cnt)
       repeat until move_x==1
         text.cls
         DrawBackground(board_position,season,score,no_players)
         color:=white
         DrawCharacter (character_y, character_x, color, $21)
         DrawCharacter (character_y, character_x+1, color, $22)
         DrawCharacter (character_y+1,character_x,color,$41)
         DrawCharacter (character_y+1,character_x+1,color,$42)
         drawtruck(move_x,19)
         text.Updatescreen
         waitcnt(2000_000 + cnt)
         move_x--

    '' POSITION BADDIES AND TRAFFIC

    '' Determine if baddie1 should be introduced.
    if b1_drive==0  '' If baddie1 does not exit, generate a position to appear.
       b1_rnd:=rr.random // 30  '' Roll the dice to see if he'll appear
       if b1_rnd== 1
         b1_drive:=1  '' There he is


    if b1_drive == 1 '' Since Baddie 1 does now exist, place him on the screen
       b1_drive:=2
       b1_pos_y:=2
       b1_pos_x:=rr.random // 20  '' Find a random x position for him.
       if b1_pos_x < 5  '' don't let him drive in the grass
         b1_pos_x:=5
       b1_weapon:=0
       b1_drive:= 2

    if b1_pos_y > 20
       b1_drive:=0


    '' Determine if traffic1 should be introduced.
    if t1_drive==0  '' If traffic1 does not exit, generate a position to appear.
       t1_rnd:=rr.random // 20  '' Roll the dice to see if he'll appear
       if t1_rnd== 1
         t1_drive:=1  '' There he is


    if t1_drive == 1 '' Since Traffic 1 does now exist, place him on the screen
       t1_drive:=2
       t1_pos_y:=2
       t1_pos_x:=rr.random // 20  '' Find a random x position for him.
       if t1_pos_x < 5  '' don't let him drive in the grass
         t1_pos_x:=5
       t1_drive:= 2

    if t1_pos_y > 20
       t1_drive:=0

    '' Determine if traffic2 should be introduced.
    if t2_drive==0  '' If traffic2 does not exit, generate a position to appear.
       t2_rnd:=rr.random // 20  '' Roll the dice to see if he'll appear
       if t2_rnd== 1
         t2_drive:=1  '' There he is


    if t2_drive == 1 '' Since Traffic 2 does now exist, place him on the screen
       t2_drive:=2
       t2_pos_y:=2
       t2_pos_x:=rr.random // 20  '' Find a random x position for him.
       if t2_pos_x < 5  '' don't let him drive in the grass
         t2_pos_x:=5
       t2_drive:= 2

    if t2_pos_y > 20
       t2_drive:=0

    '' Determine if traffic3 should be introduced.
    if t3_drive==0  '' If traffic2 does not exit, generate a position to appear.
       t3_rnd:=rr.random // 20  '' Roll the dice to see if he'll appear
       if t3_rnd== 1
         t3_drive:=1  '' There he is


    if t3_drive == 1 '' Since Traffic 3 does now exist, place him on the screen
       t3_drive:=2
       t3_pos_y:=2
       t3_pos_x:=rr.random // 20  '' Find a random x position for him.
       if t3_pos_x < 5  '' don't let him drive in the grass
         t3_pos_x:=5
       t3_drive:= 2

    if t3_pos_y > 20
       t3_drive:=0


    text.UpdateScreen



PUB  DrawBackground(pos,season_color,points,men)
   text.color(BLUE)
   text.color(BLUE)
   text.str(string("spydriver"))
   text.color(WHITE)
   text.str(string(" score:"))
   text.dec(points)
   text.out(13)
   text.str(string("                     "))
   if men == 1
     text.str(string("@",13,13))
   if men == 2
     text.str(string("@@",13,13))
   if men > 2
     text.str(string("@@@",13,13))
   if men == 0
     text.str(string(13,13,"    g a m e  o v e r"))

   text.color(season_color)

   if pos == 3
      'text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
   if pos == 2
      'text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
   if pos == 1
      'text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))

PUB Drawtruck (truck_pos_y,truck_pos_x)

    DrawCharacter (truck_pos_y, truck_pos_x, $22, $29)
    DrawCharacter (truck_pos_y, truck_pos_x+1, $22, $2A)
    DrawCharacter (truck_pos_y+1,truck_pos_x, $22,$49)
    DrawCharacter (truck_pos_y+1,truck_pos_x+1, $22,$4A)
    DrawCharacter (truck_pos_y+2,truck_pos_x, $22,$2B)
    DrawCharacter (truck_pos_y+2,truck_pos_x+1, $22,$2C)
    DrawCharacter (truck_pos_y+3,truck_pos_x, $22,$4B)
    DrawCharacter (truck_pos_y+3,truck_pos_x+1, $22,$4C)

PUB Drawtree (tree_pos_y,tree_pos_x,leaves)

    DrawCharacter (tree_pos_y, tree_pos_x, leaves, $01)
    DrawCharacter (tree_pos_y, tree_pos_x+1, leaves, $02)
    DrawCharacter (tree_pos_y+1,tree_pos_x,leaves,$03)
    DrawCharacter (tree_pos_y+1,tree_pos_x+1,leaves,$04)
    DrawCharacter (tree_pos_y+2,tree_pos_x,$22,$05)
    DrawCharacter (tree_pos_y+2,tree_pos_x+1,$22,$06)



PUB Drawladder (truck_pos_y,truck_pos_x)

    DrawCharacter (truck_pos_y+4,truck_pos_x,lgrey,$4F)
    DrawCharacter (truck_pos_y+4,truck_pos_x+1,lgrey,$50)

PUB DrawCharacter (character_y, character_x, crayon, character_chr)
     text.pokechar(character_y, character_x, crayon, character_chr)

PUB NES_Read_Gamepad : nes_bits        |  i
' //////////////////////////////////////////////////////////////////
' NES Game Paddle Read
' //////////////////////////////////////////////////////////////////
' reads both gamepads in parallel encodes 8-bits for each in format
' right game pad #1 [15..8] : left game pad #0 [7..0]
'
' set I/O ports to proper direction
' P3 = JOY_CLK      (4)
' P4 = JOY_SH/LDn   (5)
' P5 = JOY_DATAOUT0 (6)
' P6 = JOY_DATAOUT1 (7)
' NES Bit Encoding
'
' RIGHT  = %00000001
' LEFT   = %00000010
' DOWN   = %00000100
' UP     = %00001000
' START  = %00010000
' SELECT = %00100000
' B      = %01000000
' A      = %10000000

' step 1: set I/Os
DIRA [JOY_CLK] := 1 ' output
DIRA [JOY_LCH] := 1 ' output
DIRA [JOY_DATAOUT0] := 0 ' input
DIRA [JOY_DATAOUT1] := 0 ' input

' step 2: set clock and latch to 0
OUTA [JOY_CLK] := 0 ' JOY_CLK = 0
OUTA [JOY_LCH] := 0 ' JOY_SH/LDn = 0
'Delay(1)

' step 3: set latch to 1
OUTA [JOY_LCH] := 1 ' JOY_SH/LDn = 1
'Delay(1)

' step 4: set latch to 0
OUTA [JOY_LCH] := 0 ' JOY_SH/LDn = 0

' data is now ready to shift out, clear storage
nes_bits := 0

' step 5: read 8 bits, 1st bits are already latched and ready, simply save and clock remaining bits
repeat i from 0 to 7

 nes_bits := (nes_bits << 1)
 nes_bits := nes_bits | INA[JOY_DATAOUT0] | (INA[JOY_DATAOUT1] << 8)

 OUTA [JOY_CLK] := 1 ' JOY_CLK = 1
 'Delay(1)
 OUTA [JOY_CLK] := 0 ' JOY_CLK = 0

 'Delay(1)
' invert bits to make positive logic
nes_bits := (!nes_bits & $FFFF)

' //////////////////////////////////////////////////////////////////
' End NES Game Paddle Read
' //////////////////////////////////////////////////////////////////

' ////////////////////////////////////////////////////////////////////




